// i8017HW_Basic_Info_Cplusplus.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "..\Lib\pac_i8017HW.h"
#pragma comment(lib,"..\\Lib\\pac_i8017HW.lib")
static int slotIndex=-1;

int _tmain(int argc, _TCHAR* argv[])
{
	//Declaration and default value assignment
	char GainStr[5][32]={"+/-10V","+/-5V","+/-2.5V","+/-1.25V","+/-20mA"};
	char ModeStr[2][32]={"Standard Mode", "Sample and Hold Mode"};
	int slot = -1;
	int channel = 0;
	int maxCh = 8,ret;
	short jumper=0;
	int gain = 0,type=-1;
	float fValue = 0;
	int return_value = 0;
	unsigned short gVal=0;
	short oVal=0;
	for(slot=0;slot<8;slot++)
	{
		ret=pac_i8017HW_Init(slot);
		if(ret==0)
		{
			slotIndex=slot;			
			break;
		}
	}	


	if(slotIndex==-1)
	{
		printf("There is no i8017HW series module at Backplane\n",slotIndex);
		getchar();
		exit(0);
	}
	else
	{
		printf("There is an i8017HW series module at slot %d\n",slotIndex);
	}	

	printf("Choose the name of the module:\n");
	printf("  0:I-8017HW,I-8017HDW\n");
	printf("  1:I-8017HCW\n");
	scanf("%d", &type);

	pac_i8017HW_GetSingleEndJumper(slotIndex, &jumper);
	if(jumper)
	{
		maxCh=16;
        printf("\t Input Mode=Single-End and can have maximum 16 analog input\n\r");
    }
    else
    {
    	maxCh=8;
        printf("\t Input Mode=Differential and can have maximum 8 analog input\n\r");
    }

	if(type==0)
	{
		printf("\nCalibration parameter:");
		for(gain=0;gain<=4;gain++)
		{			
			pac_i8017HW_ReadGainOffset_Info(slotIndex,gain,&gVal,&oVal);
			printf("\nType code %d: %s , Gain=%u; Offset=%d",gain,GainStr[gain],gVal,oVal);
		}

		printf("Input gain for i8017HW\n");
		for(int i=0;i<5;i++)
		{
    		printf ("\n\t Select %d :  %s",i,GainStr[i]);
		}
		printf("\n\r");
		scanf("%d", &gain);
	}
	else
	{
		for(channel=0;channel<maxCh;channel++)
		{
			pac_i8017HW_Read_mA_GainOffset(slotIndex,channel,&gVal,&oVal);
			printf("CH[%d] , Gain=%u; Offset=%d\n",channel,gVal,oVal);
		}
		gain=4;
	}
	for(channel=0;channel<maxCh;channel++)
	{
		return_value = pac_i8017HW_ReadAI(slotIndex, channel, gain, &fValue);
		if( return_value==0)
		{
			
			printf("AI[%d]= %f ",channel, fValue);
			if(gain < 4)
				printf("V\n");
			else
				printf("mA\n");
		}
		else
		{
			printf("ERROR! reading AI error in the channel %d, and slot %d error code = %d\n",channel, slotIndex, return_value);
		}
	
	}

	getchar();
	getchar();
	return 0;
}